﻿using BasicInterpolation;
using SmartCowBioControl.src.objects;
using System;
using System.Collections.Generic;
using System.Linq;

namespace SmartCowBioControl.src.calcul
{
    public static class Reechantillonnage
    {
        public static List<RapidObject> GetRapidReechantillonnes(List<RapidObject> rapidsToInterpol, int pas, DateTime heuredebut, DateTime heurefin)
        {
            if (rapidsToInterpol.Count == 0)
            {
                return rapidsToInterpol;
            }

            pas = pas == 0 ? 1 : pas;

            int animal = rapidsToInterpol.First().Animal;

            double[] tabX = rapidsToInterpol.Select(r => r.DateHeureReference.ToOADate()).ToArray();
            double[] tabY = rapidsToInterpol.Select(r => r.Poids).ToArray();

            List<double> listXReechantillonnes = new List<double>();
            for (DateTime heurecourante = heuredebut; heurecourante <= heurefin; heurecourante = heurecourante.AddSeconds(pas))
            {
                listXReechantillonnes.Add(heurecourante.ToOADate());
            }
            double[] tabXReechantillonnes = listXReechantillonnes.ToArray();

            //LinearInterpolation li = new LinearInterpolation(tabX, tabY);
            CubicSplineInterpolation cs = new CubicSplineInterpolation(tabX, tabY);

            List<RapidObject> rapids = new List<RapidObject>();

            foreach (double xReechantillonne in tabXReechantillonnes)
            {
                double? yReechantillonne = cs.Interpolate(xReechantillonne);

                if (yReechantillonne.HasValue)
                {
                    rapids.Add(new RapidObject(animal, DateTime.FromOADate(xReechantillonne), Convert.ToInt32(yReechantillonne)));
                }
            }

            return rapids;
        }
    }
}
