﻿using ClosedXML.Excel;
using SmartCowBioControl.src.objects;
using System;
using System.Collections.Generic;
using System.Data.SQLite;

namespace SmartCowBioControl.src.database
{
    /// <summary>
    /// génération des données de référence de la base en allant les chercher dans le fichier excel
    /// Le but de cette class est de générer la base de donnée de référence (en executant la fonction Generate) au cas ou elle est perdue, elle n'est jamais utilisé dans l'interface graphique
    /// </summary>
    class GenerateDatabase
    {

        #region genereationBaseDonnee
        public void Generate()
        {
            var wb = new XLWorkbook("ExcelFile.xlsx");
            IXLWorksheet wks = wb.Worksheet(1);
            var usedRows = wks.RowsUsed();

            SQLiteConnection connection = new SQLiteConnection("Data Source=referencedb.db");
            connection.Open();
            SQLiteCommand command = new SQLiteCommand(connection);


            VisiteDatabase visit = new VisiteDatabase(string.Empty, 0, string.Empty, string.Empty);

            List<Eating> list_eating = new List<Eating>();

            bool InVisit = false;
            foreach (var dataRow in usedRows)
            {
                if (dataRow.RowNumber() > 1)
                {
                    //début d'une visite
                    if (dataRow.Cell(13).GetString() == "opens")
                    {
                        InVisit = true;

                        //remplir la visite sans l'heure de fin pour l'instant
                        visit.Animal = dataRow.Cell(12).GetString();
                        visit.Auge = Int32.Parse(dataRow.Cell(18).GetString());
                        DateTime date = new DateTime(2019, 06, 10);
                        TimeSpan ts = DateTime.Parse(dataRow.Cell(5).GetString() + '.' + dataRow.Cell(7).GetString()).TimeOfDay;
                        DateTime result = date + ts;
                        visit.DateHeureDebut = dataRow.Cell(15).GetString() + '.' + dataRow.Cell(4).GetString();
                        visit.m_dt_start_time = result;
                    }
                    if (InVisit)
                    {
                        if (dataRow.Cell(13).GetString() == "eating" && dataRow.Cell(14).GetString() == "State start")
                        {
                            DateTime date = new DateTime(2019, 06, 10);
                            TimeSpan ts = DateTime.Parse(dataRow.Cell(5).GetString() + '.' + dataRow.Cell(7).GetString()).TimeOfDay;

                            DateTime result = date + ts;
                            Eating eating = new Eating(0, result, DateTime.Now);
                            //regarder la row d'en dessous
                            if (dataRow.RowBelow().Cell(13).GetString() == "eating" && dataRow.RowBelow().Cell(14).GetString() == "State stop")
                            {
                                DateTime dateEndEating = new DateTime(2019, 06, 10);
                                TimeSpan tsEndEating = DateTime.Parse(dataRow.RowBelow().Cell(5).GetString() + '.' + dataRow.RowBelow().Cell(7).GetString()).TimeOfDay;
                                DateTime resultEnd = dateEndEating + tsEndEating;
                                eating.DateHeureFin = resultEnd;

                                list_eating.Add(eating);

                            }
                        }
                    }
                    if (dataRow.Cell(13).GetString() == "closes")
                    {
                        command.CommandText = "INSERT INTO visite (subject, trough, start_date, end_date) VALUES (@subject, @trough, @start_date, @end_date)";
                        InVisit = false;
                        DateTime dateEnd = new DateTime(2019, 06, 10);
                        TimeSpan tsEnd = DateTime.Parse(dataRow.Cell(5).GetString() + '.' + dataRow.Cell(7).GetString()).TimeOfDay;
                        DateTime resultEnd = dateEnd + tsEnd;
                        visit.m_dt_end_time = resultEnd;
                        command.Parameters.AddWithValue("@start_date", visit.m_dt_start_time);
                        command.Parameters.AddWithValue("@end_date", visit.m_dt_end_time);
                        command.Parameters.Add(new SQLiteParameter("subject", visit.Animal));
                        command.Parameters.Add(new SQLiteParameter("trough", visit.Auge));
                        command.ExecuteNonQuery();
                        //récuperer le dernier id ajouté dans la base
                        command.CommandText = $"SELECT * FROM visite WHERE subject like '{visit.Animal}' AND trough == {visit.Auge} AND start_date like '%{visit.m_dt_start_time.ToString("yyyy-MM-dd HH:mm:ss.f")}%' AND end_date like '%{visit.m_dt_end_time.ToString("yyyy-MM-dd HH:mm:ss.f")}%'";

                        SQLiteDataReader rdr = command.ExecuteReader();
                        int id = 0;
                        while (rdr.Read())
                        {
                            id = Int32.Parse(rdr["id"].ToString());
                        }
                        rdr.Close();
                        //ajouter les eating dans la base
                        foreach (var eating in list_eating)
                        {
                            command.CommandText = "INSERT INTO eating (id_visit, start_date, end_date) VALUES (@id_visit, @start_date, @end_date)";

                            eating.IdVisite = id;
                            command.Parameters.Add(new SQLiteParameter("id_visit", eating.IdVisite));
                            command.Parameters.AddWithValue("@start_date", eating.DateHeureDebut);
                            command.Parameters.AddWithValue("@end_date", eating.DateHeureFin);
                            command.ExecuteNonQuery();
                        }
                        //vider la liste pour la prochaine itération 
                        list_eating.Clear();
                    }

                }


            }

            connection.Close();
        }
        #endregion
    }
}
