﻿using ClosedXML.Excel;
using SmartCowBioControl.src.objects.objects;
using System;
using System.Collections.Generic;

namespace SmartCowBioControl.src.export
{
    /// <summary>
    ///     classe qui sert à gerer les exports des données en fichiers excel
    /// </summary>
    class ExportExcel
    {


        public void Export(String filePath, int PasDeTemps, int FiltreBasseFreq, bool Normalisation, double FiltreHauteFreq, double Seuil, int dephasage, List<Visite> visites)
        {

            IXLWorkbook wb = new XLWorkbook();
            IXLWorksheet ws = wb.Worksheets.Add("Filtres");
            int compteur = 2;
            foreach (var visite in visites)
            {
                ws.Cell(compteur, 1).Value = PasDeTemps;
                ws.Cell(compteur, 2).Value = FiltreBasseFreq;
                ws.Cell(compteur, 3).Value = Normalisation.ToString();
                ws.Cell(compteur, 4).Value = FiltreHauteFreq;
                ws.Cell(compteur, 4).Value = FiltreHauteFreq;
                ws.Cell(compteur, 5).Value = Seuil;
                ws.Cell(compteur, 6).Value = dephasage;

                ws.Cell(compteur, 10).Value = visite.Auge;
                ws.Cell(compteur, 11).Value = visite.Animal;
                ws.Cell(compteur, 12).Value = visite.DateLabel.ToString();
                ws.Cell(compteur, 13).Value = visite.DateHeureDebut.ToString();
                ws.Cell(compteur, 14).Value = visite.DateHeureFin.ToString();
                ws.Cell(compteur, 15).Value = visite.DureeVisite.ToString();
                ws.Cell(compteur, 16).Value = visite.IndiceJaccard;
                ws.Cell(compteur, 17).Value = visite.FrequenceSeuil;
                ws.Cell(compteur, 18).Value = visite.FrequenceVideo;
                ws.Cell(compteur, 19).Value = visite.PourcentageSeuil;
                ws.Cell(compteur, 20).Value = visite.PourcentageVideo;

                compteur++;
            }
            ws.Cell(1, 1).Value = "Pas de Temps (s)";
            ws.Cell(1, 2).Value = "Filtre Basse fréquences (s)";
            ws.Cell(1, 3).Value = "Normalisation";
            ws.Cell(1, 4).Value = "Filtre haute fréquence (s)";
            ws.Cell(1, 5).Value = "Seuil";
            ws.Cell(1, 6).Value = "Dephasage";
            ws.Cell(1, 10).Value = "Auge";
            ws.Cell(1, 11).Value = "Animal";
            ws.Cell(1, 12).Value = "Date";
            ws.Cell(1, 13).Value = "Heure Debut";
            ws.Cell(1, 14).Value = "Heure Fin";
            ws.Cell(1, 15).Value = "Durée Visite";
            ws.Cell(1, 16).Value = "Indice Jaccard";
            ws.Cell(1, 17).Value = "Fréquence Seuil";
            ws.Cell(1, 18).Value = "Fréquence Vidéo";
            ws.Cell(1, 19).Value = "Pourcentage Seuil";
            ws.Cell(1, 20).Value = "Pourcentage Vidéo";

            wb.SaveAs(filePath);
        }

    }
}
