﻿using ClosedXML.Excel;
using System;
using System.Collections.Generic;
using System.Data.SQLite;
using System.Text;

namespace Module1
{
    /// <summary>
    /// génération des données de référence de la base en allant les chercher dans le excel 
    /// </summary>
    class GenerateDatabase
    {
        public void Generate()
        {
            Console.WriteLine("Debut génération");
            var wb = new XLWorkbook("ExcelFile.xlsx");
            IXLWorksheet wks = wb.Worksheet(1);
            var usedRows = wks.RowsUsed();

            SQLiteConnection connection = new SQLiteConnection("Data Source=referencedb.db");
            connection.Open();
            SQLiteCommand command = new SQLiteCommand(connection);


            Visit visit = new Visit(string.Empty, 0, string.Empty , string.Empty);

            List<Eating> list_eating = new List<Eating>();

            bool InVisit = false;
            foreach (var dataRow in usedRows)
            {
                if (dataRow.RowNumber() > 1)
                {

                    //début d'une visite
                    if (dataRow.Cell(13).GetString() == "opens")
                    {
                        InVisit = true;

                        //remplir la visite sans l'heure de fin pour l'instant
                        visit.m_subject = dataRow.Cell(12).GetString();
                        visit.m_trough = Int32.Parse(dataRow.Cell(18).GetString());
                        visit.m_start_time = dataRow.Cell(1).GetString() + '.' + dataRow.Cell(4).GetString();
                        visit.m_dt_start_time = dataRow.Cell(1).GetDateTime();
                    }
                    if (InVisit)
                    {
                        if (dataRow.Cell(13).GetString() == "eating" && dataRow.Cell(14).GetString() == "State start")
                        {
                            Eating eating = new Eating(0, dataRow.Cell(1).GetDateTime(), DateTime.Now);
                            //regarder la row d'en dessous
                            if (dataRow.RowBelow().Cell(13).GetString() == "eating" && dataRow.RowBelow().Cell(14).GetString() == "State stop")
                            {
                                eating.m_dt_end_time = dataRow.RowBelow().Cell(1).GetDateTime();
                                
                                list_eating.Add(eating);

                            }
                        }
                    }
                    if (dataRow.Cell(13).GetString() == "closes")
                    {
                        command.CommandText = "INSERT INTO visite (subject, trough, start_date, end_date) VALUES (@subject, @trough, @start_date, @end_date)";
                        InVisit = false;
                        visit.m_dt_end_time = dataRow.Cell(1).GetDateTime();
                        visit.m_end_time = dataRow.Cell(1).GetString()+'.'+dataRow.Cell(4).GetString();
                        command.Parameters.AddWithValue("@start_date", visit.m_dt_start_time);
                        command.Parameters.AddWithValue("@end_date", visit.m_dt_end_time);
                        command.Parameters.Add(new SQLiteParameter("subject", visit.m_subject));
                        command.Parameters.Add(new SQLiteParameter("trough", visit.m_trough));
                        //command.Parameters.Add(new SQLiteParameter("start_date", visit.m_start_time));
                        //command.Parameters.Add(new SQLiteParameter("end_date", visit.m_end_time));
                        command.ExecuteNonQuery();
                        //récuperer le dernier id ajouté dans la base
                        command.CommandText = $"SELECT * FROM visite WHERE subject == '{visit.m_subject}' AND trough == {visit.m_trough} AND start_date == '{visit.m_dt_start_time.ToString("yyyy-MM-dd HH:mm:ss.fff")}' AND end_date == '{visit.m_dt_end_time.ToString("yyyy-MM-dd HH:mm:ss.fff")}'";
                       // Console.WriteLine(visit.m_dtend_time.ToString("yyyy-MM-dd HH:mm:ssfff"));
                      //Console.WriteLine(visit.m__dtstart_time.ToString("yyyy-MM-dd HH:mm:ss.fff"));
                       /// Console.WriteLine((visit.m_dtend_time.ToString("s").Replace("/", "-") + "." + visit.m_dtend_time.Millisecond).Replace("T", " "));

                        using SQLiteDataReader rdr = command.ExecuteReader();
                        int id = 0;
                        while (rdr.Read())
                        {
                            id = Int32.Parse(rdr["id"].ToString());
                             Console.WriteLine(id);
                        }
                        rdr.Close();
                        //ajouter les eating dans la base
                        foreach (var eating in list_eating)
                        {
                            command.CommandText = "INSERT INTO eating (id_visit, start_date, end_date) VALUES (@id_visit, @start_date, @end_date)";

                            eating.m_id_visite = id;
                            command.Parameters.Add(new SQLiteParameter("id_visit", eating.m_id_visite));
                            command.Parameters.AddWithValue("@start_date", eating.m_dt_start_time);
                            command.Parameters.AddWithValue("@end_date", eating.m_dt_end_time);
                            //command.Parameters.Add(new SQLiteParameter("start_date", eating.m_start_time));
                            //command.Parameters.Add(new SQLiteParameter("end_date", eating.m_end_time));
                            command.ExecuteNonQuery();
                            //Console.WriteLine("Ajout dans la base fait");
                        }
                        //vider la liste pour la prochaine itération 
                        list_eating.Clear();
                    }

                }


            }

            connection.Close();

            Console.WriteLine("Fin génération");
        }

    }
}
