﻿using System;
using System.Collections.Generic;
using System.Text;
using ClosedXML.Excel;
using System.Data.SQLite;
namespace Module1
{
    /// <summary>
    /// Génération de la base de donnée des données rapides 
    /// </summary>
    class GenerateRapidDatabase
    {

        public GenerateRapidDatabase()
        {
          
        }

        /// <summary>
        /// Recuperer les rapid entre les datetimes
        /// </summary>
        /// <param name="firstdate"></param>
        /// <param name="seconddate"></param>
        /// <param name="auge"> numéro de l'auge </param>
        /// <returns></returns>
        public List<RapidFile> SelectDateTimeInterval(DateTime firstdate, DateTime seconddate, int auge)
        {

            List<RapidFile> Rapids = new List<RapidFile>();

            SQLiteConnection connection = new SQLiteConnection("Data Source=rapiddb.db");
            connection.Open();
            SQLiteCommand command = new SQLiteCommand(connection);

            command.CommandText = $"SELECT * FROM 'Auge {auge}' WHERE date BETWEEN '{firstdate.ToString("yyyy-MM-dd HH:mm:ss.f")}' AND '{seconddate.ToString("yyyy-MM-dd HH:mm:ss.f")}'";

            SQLiteDataReader rdr = command.ExecuteReader();

            while (rdr.Read())
            {
                Console.WriteLine(rdr.GetDateTime(2));
              //  RapidFile rapidfile = new RapidFile(rdr.GetInt32(2), rdr.GetDateTime(3), Int32.Parse(rdr["animal"].ToString()));

//                Rapids.Add(rapidfile);

            }


            rdr.Close();

            return Rapids;
        }
        public void GetFileData(string excelPath, int auge)
        {
            SQLiteConnection connection = new SQLiteConnection("Data Source=rapiddb.db");
            connection.Open();
            SQLiteCommand command = new SQLiteCommand(connection);
            var wb = new XLWorkbook(excelPath);
            IXLWorksheet wks = wb.Worksheet("Rapid");
            var usedRows = wks.RowsUsed();

            DateTime dt = new DateTime(2019, 06, 10);

            RapidFile rapid = new RapidFile();
            foreach (var dataRow in usedRows)
            {
                if (dataRow.RowNumber() > 1)
                {
                    command.CommandText = $"INSERT INTO 'Auge {auge}' (poid, date, animal) VALUES (@poid, @date, @animal)";
                    rapid.m_weight = Int32.Parse(dataRow.Cell(5).GetString());
                    TimeSpan Ts = dataRow.Cell(2).GetTimeSpan();
                    rapid.m_date = dt + Ts;
                    rapid.m_animal = Int32.Parse(dataRow.Cell(4).GetString());
                    command.Parameters.AddWithValue("@date", rapid.m_date);
                    command.Parameters.Add(new SQLiteParameter("@animal", rapid.m_animal));
                    command.Parameters.Add(new SQLiteParameter("@poid", rapid.m_weight));
                    command.ExecuteNonQuery();
                }
            }
            Console.WriteLine("Fin");
        }


        public void GenerateAllTable()
        {
            SQLiteConnection connection = new SQLiteConnection("Data Source=rapiddb.db");
            connection.Open();
            SQLiteCommand command = new SQLiteCommand(connection);
            for (int i = 15; i <= 26; i++)
            {
                command.CommandText = $"CREATE TABLE 'Auge {i}'('id'	INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,	'poid'	INTEGER NOT NULL,'date' INTEGER NOT NULL,'animal' INTEGER NOT NULL);";
                command.ExecuteNonQuery();

            }
        }
    }
}
