﻿using ClosedXML.Excel;
using SmartCowBioControl.src.objects.objects;
using System;
using System.Collections.Generic;

namespace SmartCowBioControl.src.export
{
    /// <summary>
    /// Exports des données en Excel.
    /// </summary>
    public class ExportExcel
    {
        public void Export(
            string filePath,
            int pasDeTemps,
            double filtreHauteFreq,
            int filtreBasseFreq,
            bool normalisation,
            int seuilNbDecimales,
            int dephasage,
            List<Visite> visites)
        {
            IXLWorkbook wb = new XLWorkbook();
            IXLWorksheet ws = wb.AddWorksheet("Filtres");

            int ligne = 1;

            ws.Cell(ligne, 1).Value = "Pas de Temps (s)";
            ws.Cell(ligne, 2).Value = "Filtre haute fréquence (s)";
            ws.Cell(ligne, 3).Value = "Filtre basse fréquence (s)";
            ws.Cell(ligne, 4).Value = "Normalisation";
            ws.Cell(ligne, 5).Value = "Seuil nb decimales";
            ws.Cell(ligne, 6).Value = "Dephasage";

            ws.Cell(ligne, 9).Value = "Auge";
            ws.Cell(ligne, 10).Value = "Animal";
            ws.Cell(ligne, 11).Value = "Date";
            ws.Cell(ligne, 12).Value = "Heure Debut";
            ws.Cell(ligne, 13).Value = "Heure Fin";
            ws.Cell(ligne, 14).Value = "Durée Visite";
            ws.Cell(ligne, 15).Value = "Seuil";
            ws.Cell(ligne, 16).Value = "Nb max locaux";
            ws.Cell(ligne, 17).Value = "Indice Jaccard";
            ws.Cell(ligne, 18).Value = "Fréquence Seuil";
            ws.Cell(ligne, 19).Value = "Fréquence Vidéo";
            ws.Cell(ligne, 20).Value = "Pourcentage Seuil";
            ws.Cell(ligne, 21).Value = "Pourcentage Vidéo";

            foreach (var visite in visites)
            {
                ligne++;

                ws.Cell(ligne, 1).Value = pasDeTemps;
                ws.Cell(ligne, 2).Value = filtreHauteFreq;
                ws.Cell(ligne, 3).Value = filtreBasseFreq;
                ws.Cell(ligne, 4).Value = normalisation.ToString();
                ws.Cell(ligne, 5).Value = seuilNbDecimales;
                ws.Cell(ligne, 6).Value = dephasage;

                ws.Cell(ligne, 9).Value = visite.Auge;
                ws.Cell(ligne, 10).Value = visite.Animal;
                ws.Cell(ligne, 11).Value = visite.DateLabel.ToString();
                ws.Cell(ligne, 12).Value = visite.DateHeureDebut.ToString();
                ws.Cell(ligne, 13).Value = visite.DateHeureFin.ToString();
                ws.Cell(ligne, 14).Value = visite.DureeVisite.ToString();
                ws.Cell(ligne, 15).Value = visite.Seuil;
                ws.Cell(ligne, 16).Value = visite.NbMaxLocaux;
                ws.Cell(ligne, 17).Value = visite.IndiceJaccard;
                ws.Cell(ligne, 18).Value = visite.FrequenceSeuil;
                ws.Cell(ligne, 19).Value = visite.FrequenceVideo;
                ws.Cell(ligne, 20).Value = visite.PourcentageSeuil;
                ws.Cell(ligne, 21).Value = visite.PourcentageVideo;
            }

            wb.SaveAs(filePath);
        }
    }
}
