﻿namespace SmartCowBioControl.src.calcul
{
    public class Parametres
    {
        // ====================================================================================================
        // PROPRIETES
        // ====================================================================================================

        public bool IsPasDeTempsActif { get; set; }

        public bool IsFiltreHauteFrequenceActif { get; set; }

        public bool IsFiltreBasseFrequenceActif { get; set; }

        public bool IsNormalisationActif { get; set; }

        public bool IsSeuilActif { get; set; }

        public int PasDeTemps { get; set; }

        public double FiltreHauteFrequence { get; set; }

        public int FiltreBasseFrequence { get; set; }

        public int SeuilNbDecimales { get; set; }

        public double SeuilMin { get; set; }

        public double SeuilMax { get; set; }

        public int FenetreCalculMaxLocaux { get; set; }

        public int IntervalleDeTemps { get; set; }

        public int DecalageDansVisite { get; set; }

        // ====================================================================================================
        // CONSTRUCTEURS
        // ====================================================================================================

        public Parametres()
        {
            this.IsPasDeTempsActif = true;
            this.IsFiltreHauteFrequenceActif = true;
            this.IsFiltreBasseFrequenceActif = true;
            this.IsNormalisationActif = true;
            this.IsSeuilActif = true;

            this.PasDeTemps = 1;
            this.FiltreHauteFrequence = 3;
            this.FiltreBasseFrequence = 15;
            this.SeuilNbDecimales = 2;
            this.SeuilMin = 0.02;
            this.SeuilMax = 0.1;
            this.FenetreCalculMaxLocaux = 2;

            this.IntervalleDeTemps = 5;
            this.DecalageDansVisite = 0;
        }
    }
}
