﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace SmartCowBioControl.src.objects
{
    /// <summary>
    /// selection des données d'une auge dans un interval
    /// </summary>
    class Rapid_time_selection : Rapid
    {
        Dictionary<DateTime, int> m_TimeAndWeight = new Dictionary<DateTime, int>();

        public Rapid_time_selection(string pathRapidFile) : base(pathRapidFile)
        {
        }

        /// <summary>
        /// Intervalle de recherche dans le fichier, entrer l'intervalle de recherche en paramettre
        /// </summary>
        /// <param name="a">Première date</param>
        /// <param name="b">Seconde date</param>
        public Dictionary<DateTime, int> SelectTimeInterval(DateTime a, DateTime b)
        {
            StreamReader file = new StreamReader(m_CurrentRapidFile, Encoding.UTF8);
            string data;

            string importantData;
            int weight;
            string filename = Path.GetFileNameWithoutExtension(m_CurrentRapidFile);

            //créer l'objet datetime avec le nom de fichier+les secondes a ajoute après 
            DateTime dt = DateTime.ParseExact(filename, "yyMMdd", null);

            while ((data = file.ReadLine()) != null)
            {
                importantData = data.Substring(0, 5);

                weight = Int32.Parse(data.Substring(15, 6));

                DateTime dttemp = dt.AddSeconds(int.Parse(importantData));

                if (dttemp > a && dttemp < b)
                {
                    m_TimeAndWeight.Add(dttemp, weight);
                }
            }

            return m_TimeAndWeight;
        }
    }
}
